/*Ghassan Fakher
 * section 4
 * 201301739
 gkf01*/
public class CircArrayQueue {
	private int[] array;	
	private int head;		//head will change every time you dequeue
	private int tail;		//tail will change every time you enqueue
	private int size;		//a counter to keep track of the number of elements in the array
	
	/*
	 * no argument constructor
	 * creates an array of 5 elements
	 */
	public CircArrayQueue()
	{
		array = new int[5];
		head = 0;
		tail = 0;
		size = 0;
	}
	/*
	 * @param int[] myArray
	 * creates an array of size myArray + 1 and copies elements of myArray to array
	 */
	public CircArrayQueue(int[] myArray)
	{
		array = new int[myArray.length + 1];
		for(int i = 0; i < myArray.length; i++)
		{
			array[i] = myArray[i];
		}
		head = 0;
		tail = array.length  + 1;
		size = myArray.length;
	}
	/*
	 * @param int element
	 * inserts the element to tail of queue
	 * increments tail by 1
	 * head remains the same
	 */
	public void enqueue(int element)
	{
		if(tail == array.length)
		{
			System.out.println("Cant add: Queue is Full");
		}
		else
		{
			array[tail] = element;
			tail++;
			size++;
		}	
	}
	/*
	 * @return int the element to be removed from the queue
	 * removes the integer from the head of the queue by incrementing head by 1
	 * tail remains the same
	 */
	public int dequeue()
	{
		head++;
		size--;
		return array[head - 1];
	}
	/*
	 * @return boolean checks whether the queue is empty or not
	 */
	public boolean isEmpty()
	{
		return (head == tail);
	}
	/*
	 * @return boolean to check whether the queue is full or not
	 */
	public boolean isFull()
	{
		return (tail == head + 1);
	}
	//@return int head of the queue
	public int getHead()
	{
		return head;
	}
	//@return int tail of the queue
	public int getTail()
	{
		return tail;
	}
	/*
	 * @return int representing the number of elements in the queue
	 */
	public int size()
	{
		return size;
	}
	//outputs the queue
	public String toString()
	{
		String s = "";
		for(int i = head; i < tail; i++)
		{
			s += array[i] + ", ";
		}
		return s;
	}
}
